#include "ninox.h"

int DEBUG = 0;
char *CurrentFile = NULL;

int InteractiveMode = 0;
int DoCutout = 1;	// locate object and move it to the centre
int ForceProcess = 0;   // Force Processing even if image data found near edge
int newWidth = -1;
int newHeight = -1;
int White = 255;
int AllowOverwrite = 0;
int HistoProtect=1;
int InputHistoStretch = -1;  // Unknown (auto)
int HistoStretch = 0;
int UpScale = 1;
int DownScale = 1;
int UpScale_Smoothing = -1;
int UpScale_Smoothing_When = SMOOTHING_BEFORE;
int ThreshHold = 30;
int MinPixels = 250;
int WantDebayer = 0;
int InputFilter = 0;
int doInvertImage = 0;  // Do we invert the image when loading?
double InputFilter_ThreshHold = 0.2;
double Gamma = 1.0;
int ChangeGamma = 0;
int CutX = 360;
int CutY = 360;
double BayerBoost = 1.0;
int NoSave = 0;
char *OutDir = NULL;	// Where to write converted files
int WriteEmptyFiles = 1;
int Quiet=0;
char *StackFile = NULL;
char *MergeFile = NULL;
double MergeThreshHold = 0.2;
int StackCount=0;
int StackMax=100000;
int forceWriteEmptyFiles = 0;
int HNoiseFilter = 0;
int SubDirs = 1;		// create subdirs for "-2" "-3" etc

int Sub_x = 0;		// subregion for non-central cutout
int Sub_y = 0;
int cur_Sub_x = 0;
int cur_Sub_y = 0;

int StreamFilter = 0;
int StreamFilter_History = 5; 	// size of sliding window

int PopFilter = 0;
int PopFilter_When = POPFILTER_BEFORE; // BEFORE or AFTER processing

// Parameters for quality estimator
int QWriteIntermediateFiles = 0;// Write out PPM files for each sample level
int QRenumberFiles = 0;		// renumber files according to quality
int QEstimator = 0;		// Enable the quality estimator
int QSUBSAMPLE_MIN = 3;
int QSUBSAMPLE_MAX = 5;
int QualityFunction = GRADIENT;
int QHISTO_MIN = -1;
int QHISTO_MAX = -1;
char * QHISTO_FILE = "./histo.txt";

// Image morphing variables
int Morphing = 0;		// Set to 1 to enable
char *Morph_Ref = NULL;		// The reference image
int Morph_Across = -1;	// Given by user, or auto calculated
int Morph_Down = -1;;	// Given by user or auto calculated
int Morph_Iterations = 1;
int Morph_Drift = 2;
int Morph_Debug = 0;

int OutputFileType = -1;
int OutputFileDepth = -1;

// Image rotation
int do_Rotate = 0;	// default: off
double RotateAngle = 0;	// rotation angle
int RotateCutoff = 45;

// Gain compensation
int ApplyGainComp = 0;

// variables for test mode, subsampling
// The first image is used as the source, the subsampling mode creates
// a number of simulated samples.
int SubsampleMode = 0;                // 1 means enter subsampling mode
int Subsample_pixel_width = 10;       // width of simulated pixel
int Subsample_pixel_height = 10;// height of simulated pixel
int Subsample_xpixels = 640;  // number of horizontal pixels
int Subsample_ypixels = 480;  // number of vertical pixels
int Subsample_nframes = 100;  // number of simulated frames to generate
int Subsample_upscale = 0;    // upscale generated frames by this amount
int Subsample_smooth = 0;     // smooth after upsampling
double Subsample_min_offset = 0;// (min,max) control the offset location in source pixels
double Subsample_max_offset = 5;
int Subsample_noise = 0;      // percent noise to add
int Subsample_scan=0;         // 1 means non-random offsets
char *Subsample_prefix = "sample_";   // prefix for output files

int DoFFT = 0;

int DetectBrokenFrames = 0;
int DBF_TYPE = DBF_PLANET;
int DBF_EDGE_COUNT = 50;
int DBF_DIFF = 15;		// For DetectBrokenFrames, lines count
				// if their difference to above or below is
				// more than DBF_DIFF * the average
				//
int DetectHotPixels = 0;

int doLevelsAdjust = 0;
int LevelsMin = 0;
int LevelsMax = 0;

char * DarkFrame = NULL;
double DarkFrame_Scale = 1.0;

// Subregion support: After the normal centering process we then
// cutout and use a rectangular subregion.

int EnableSubRegion = 0;
int SR_X1 = 0;
int SR_X2 = 0;
int SR_Y1 = 0;
int SR_Y2 = 0;
