#define COLOR_FORMAT7_MONO8 	1
#define COLOR_FORMAT7_YUV411	2
#define COLOR_FORMAT7_YUV422	3
#define COLOR_FORMAT7_YUV444	4
#define COLOR_FORMAT7_RGB8	5
#define COLOR_FORMAT7_MONO16	6
#define COLOR_FORMAT7_RGB16	7

#include "../ninox.h"
#include <time.h>
#include <SDL/SDL.h>

#ifndef MSWIN32
#include <X11/Xlib.h>
#include <X11/extensions/Xvlib.h>
#include <ctype.h>

#define HAVE_XV
#endif

typedef struct _xvinfo
{
#ifdef HAVE_XV
  Display *dpy;
  XvAdaptorInfo *ainfo;
  XvEncodingInfo *encodings;
  XvImageFormatValues *formats;
  unsigned int nencode, nadaptors;
  int numImages;
  int ImageEncodings;
#endif
  int max_height;
  int max_width;
} xvinfo_t;

void GetXvInfo(xvinfo_t *xvinfo);
SDL_Overlay * init_display(int width, int height, int bpp);
void FatalError(char *str);
void Message(char *str);
void playfile(char *file);
void playdir(char *file);
void playarchive(char *file);
void SDLDisplayArea(int width, int height, SDL_Overlay *so);
void display_image(struct Image *img);
void ByteSwap(unsigned char *data, int nbytes);
void SubtractScale(unsigned int *buf1, unsigned int *buf2, int npixels, double m);
void UnsharpMask(unsigned int *buf1, int width, int height, double m);
void AlphaTrimmedMean(unsigned int *buffer, int width, int height);

